osgAnimation::RigTransformSoftware Class Reference

This class manage format for software skinning. More...

`#include <RigTransformSoftware>`

Inheritance diagram for osgAnimation::RigTransformSoftware:

## Classes

class | BonePtrWeight
class | VertexGroup
| map a set of boneinfluence to a list of vertex indices sharing this set More...

## Public Types

typedef std::pair< unsigned int, float > | LocalBoneIDWeight
typedef std::vector< BonePtrWeight > | BonePtrWeightList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| RigTransformSoftware ()
| RigTransformSoftware (const RigTransformSoftware &rts, const osg::CopyOp &copyop)
| META_Object (osgAnimation, RigTransformSoftware) virtual void operator()(RigGeometry &)
virtual bool | prepareData (RigGeometry &)
template<class V>
void | compute (const osg::Matrix &transform, const osg::Matrix &invTransform, const V *src, V *dst)
template<class V>
void | computeNormal (const osg::Matrix &transform, const osg::Matrix &invTransform, const V *src, V *dst)
Public Member Functions inherited from osgAnimation::RigTransform
| RigTransform ()
| RigTransform (const RigTransform &org, const osg::CopyOp &copyop)
| META_Object (osgAnimation, RigTransform) virtual void operator()(RigGeometry &)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::vector< VertexGroup > | VertexGroupList

## Protected Member Functions

virtual bool | init (RigGeometry &)
void | buildMinimumUpdateSet (const RigGeometry &rig)
Protected Member Functions inherited from osgAnimation::RigTransform
virtual | ~RigTransform ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

bool | _needInit
std::map< std::string, bool > | _invalidInfluence
VertexGroupList | _uniqVertexGroupList
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

This class manage format for software skinning.

## Member Typedef Documentation

## BonePtrWeightList

typedef std::vector<BonePtrWeight> osgAnimation::RigTransformSoftware::BonePtrWeightList

## LocalBoneIDWeight

typedef std::pair<unsigned int, float> osgAnimation::RigTransformSoftware::LocalBoneIDWeight

## VertexGroupList

typedef std::vector<VertexGroup> osgAnimation::RigTransformSoftware::VertexGroupList

protected

## Constructor & Destructor Documentation

## RigTransformSoftware() [1/2]

osgAnimation::RigTransformSoftware::RigTransformSoftware | ( |  | ) |

Referenced by META_Object(), and RigTransformSoftware().

## RigTransformSoftware() [2/2]

osgAnimation::RigTransformSoftware::RigTransformSoftware | ( | const RigTransformSoftware & | rts,
|  | const osg::CopyOp & | copyop )

References RigTransformSoftware().

## Member Function Documentation

## buildMinimumUpdateSet()

void osgAnimation::RigTransformSoftware::buildMinimumUpdateSet | ( | const RigGeometry & | rig | ) |

protected

## compute()

template<class V>

void osgAnimation::RigTransformSoftware::compute | ( | const osg::Matrix & | transform,
|  | const osg::Matrix & | invTransform,
|  | const V * | src,
|  | V * | dst )

inline

References _uniqVertexGroupList, osgAnimation::RigTransformSoftware::VertexGroup::computeMatrixForVertexSet(), osgAnimation::RigTransformSoftware::VertexGroup::getMatrix(), and osgAnimation::RigTransformSoftware::VertexGroup::getVertices().

## computeNormal()

template<class V>

void osgAnimation::RigTransformSoftware::computeNormal | ( | const osg::Matrix & | transform,
|  | const osg::Matrix & | invTransform,
|  | const V * | src,
|  | V * | dst )

inline

References _uniqVertexGroupList, osgAnimation::RigTransformSoftware::VertexGroup::computeMatrixForVertexSet(), osgAnimation::RigTransformSoftware::VertexGroup::getMatrix(), osgAnimation::RigTransformSoftware::VertexGroup::getVertices(), and osg::Matrixd::transform3x3().

## init()

virtual bool osgAnimation::RigTransformSoftware::init | ( | RigGeometry & |  | ) |

protected virtual

## META_Object()

osgAnimation::RigTransformSoftware::META_Object | ( | osgAnimation | ,
|  | RigTransformSoftware | ) &

References RigTransformSoftware().

## prepareData()

virtual bool osgAnimation::RigTransformSoftware::prepareData | ( | RigGeometry & |  | ) |

virtual

to call manually when a skeleton is reacheable from the rig in order to prepare technic data before rendering

Reimplemented from osgAnimation::RigTransform.

## Member Data Documentation

## _invalidInfluence

std::map<std::string,bool> osgAnimation::RigTransformSoftware::_invalidInfluence

protected

## _needInit

bool osgAnimation::RigTransformSoftware::_needInit

protected

## _uniqVertexGroupList

VertexGroupList osgAnimation::RigTransformSoftware::_uniqVertexGroupList

protected

Referenced by compute(), and computeNormal().

The documentation for this class was generated from the following file:

- RigTransformSoftware